Improved the daemon testing, including adding a test to ensure that
[rsync/rsync.git] / testsuite / rsync.fns
1 #! /bin/sh
2
3 # Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5 # General-purpose test functions for rsync.
6
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License version
9 # 2 as published by the Free Software Foundation.
10 #
11 # This program is distributed in the hope that it will be useful, but
12 # WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
14 # Lesser General Public License for more details.
15
16 # You should have received a copy of the GNU Lesser General Public
17 # License along with this program; if not, write to the Free Software
18 # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
21 tmpdir="$scratchdir"
22 fromdir="$tmpdir/from"
23 todir="$tmpdir/to"
24 chkdir="$tmpdir/chk"
25
26 # For itemized output:
27 all_plus='+++++++++'
28 allspace='         '
29 dots='.....' # trailing dots after changes
30
31 # Berkley's nice.
32 PATH="$PATH:/usr/ucb"
33
34 if diff -u "$srcdir/testsuite/rsync.fns" "$srcdir/testsuite/rsync.fns" >/dev/null 2>&1; then
35     diffopt="-u"
36 else
37     diffopt="-c"
38 fi
39
40 HOME="$scratchdir"
41 export HOME
42
43 runtest() {
44     echo $ECHO_N "Test $1: $ECHO_C"
45     if eval "$2"
46     then
47         echo "$ECHO_T   done."
48         return 0
49     else
50         echo "$ECHO_T failed!"
51         return 1
52     fi
53 }
54
55 # Call this if you want to filter out verbose messages (-v or -vv) from
56 # the output of an rsync run (whittling the output down to just the file
57 # messages).  This isn't needed if you use -i without -v.
58 filter_outfile() {
59     sed -e '/^building file list /d' \
60         -e '/^sending incremental file list/d' \
61         -e '/^created directory /d' \
62         -e '/^done$/d' \
63         -e '/ --whole-file$/d' \
64         -e '/^total: /d' \
65         -e '/^client charset: /d' \
66         -e '/^server charset: /d' \
67         -e '/^$/,$d' \
68         <"$outfile" >"$outfile.new"
69     mv "$outfile.new" "$outfile"
70 }
71
72 printmsg() {
73     echo "$1"
74 }
75
76 rsync_ls_lR() {
77     find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls" $TLS_ARGS
78 }
79
80 check_perms() {
81     perms=`"$TOOLDIR/tls" "$1" | sed 's/^[-d]\(.........\).*/\1/'`
82     if test $perms = $2; then
83         return 0
84     fi
85     echo "permissions: $perms on $1"
86     echo "should be:   $2"
87     test_fail "failed test $3"
88 }
89
90 rsync_getgroups() { 
91     "$TOOLDIR/getgroups"
92 }
93
94
95 ####################
96 # Build test directories $todir and $fromdir, with $fromdir full of files.
97
98 hands_setup() {
99     # Clean before creation
100     rm -rf "$fromdir"
101     rm -rf "$todir"
102
103     [ -d "$tmpdir" ] || mkdir "$tmpdir"
104     [ -d "$fromdir" ] || mkdir "$fromdir"
105     [ -d "$todir" ] || mkdir "$todir"
106
107     # On some BSD systems, the umask affects the mode of created
108     # symlinks, even though the mode apparently has no effect on how
109     # the links behave in the future, and it cannot be changed using
110     # chmod!  rsync always sets its umask to 000 so that it can
111     # accurately recreate permissions, but this script is probably run
112     # with a different umask. 
113
114     # This causes a little problem that "ls -l" of the two will not be
115     # the same.  So, we need to set our umask before doing any creations.
116
117     # set up test data
118     touch "$fromdir/empty"
119     mkdir "$fromdir/emptydir"
120
121     # a hundred lines of text or so
122     rsync_ls_lR "$srcdir" > "$fromdir/filelist"
123
124     echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
125     umask 0
126     ln -s nolf "$fromdir/nolf-symlink"
127     umask 022
128
129     cat "$srcdir"/*.c > "$fromdir/text"
130     mkdir "$fromdir/dir"
131     cp "$fromdir/text" "$fromdir/dir"
132     mkdir "$fromdir/dir/subdir"
133     echo some data > "$fromdir/dir/subdir/foobar.baz"
134     mkdir "$fromdir/dir/subdir/subsubdir"
135     if [ -r /etc ]; then
136         ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
137     else
138         ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
139     fi
140     mkdir "$fromdir/dir/subdir/subsubdir2"
141     if [ -r /bin ]; then
142         ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
143     else
144         ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
145     fi
146
147 #      echo testing head:
148 #      ls -lR "$srcdir" | head -10 || echo failed
149 }
150
151
152 ####################
153 # Many machines do not have "mkdir -p", so we have to build up long paths.
154 # How boring.  
155 makepath() {
156     for p in "${@}"; do
157         (echo "        makepath $p"
158
159         # Absolut Unix.
160         if echo $p | grep '^/' >/dev/null
161         then
162             cd /
163         fi
164     
165         # This will break if $p contains a space.
166         for c in `echo $p | tr '/' ' '`
167         do 
168             if [ -d "$c" ] || mkdir "$c" 
169             then
170                 cd "$c" || return $?
171             else
172                 echo "failed to create $c" >&2; return $?
173             fi
174         done)
175     done
176 }
177
178
179
180 ###########################
181 # Run a test (in '$1') then compare directories $2 and $3 to see if
182 # there are any difference.  If there are, explain them.
183
184 # So normally basically $1 should be an rsync command, and $2 and $3
185 # the source and destination directories.  This is only good when you
186 # expect to transfer the whole directory exactly as is.  If some files
187 # should be excluded, you might need to use something else.
188
189 checkit() {
190     failed=
191
192     # We can just write everything to stdout/stderr, because the
193     # wrapper hides it unless there is a problem.
194
195     echo "Running: \"$1\""  
196     eval "$1" 
197     status=$?
198     if [ $status != 0 ]; then
199         failed="YES";
200     fi
201
202     echo "-------------"
203     echo "check how the directory listings compare with diff:"
204     echo ""
205     ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
206     ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
207     diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
208
209     echo "-------------"
210     echo "check how the files compare with diff:"
211     echo ""
212     if [ "x$4" != x ]; then
213         echo "  === Skipping (as directed) ==="
214     else
215         diff -r $diffopt "$2" "$3" || failed=YES
216     fi
217
218     echo "-------------"
219     if [ -z "$failed" ] ; then
220         return 0
221     else
222         return 1
223     fi
224 }
225
226
227 build_rsyncd_conf() {
228     # Build an appropriate configuration file
229     conf="$scratchdir/test-rsyncd.conf"
230     echo "building configuration $conf"
231
232     port=2612
233     pidfile="$scratchdir/rsyncd.pid"
234     logfile="$scratchdir/rsyncd.log"
235     hostname=`uname -n`
236
237     cat >"$conf" <<EOF
238 # rsyncd configuration file autogenerated by $0
239
240 pid file = $pidfile
241 use chroot = no
242 munge symlinks = no
243 hosts allow = localhost 127.0.0.0/24 192.168.0.0/16 10.0.0.0/8 $hostname
244 log file = $logfile
245 log format = %i %h [%a] %m (%u) %l %f%L
246 transfer logging = yes
247 exclude = ? foobar.baz
248 max verbosity = 9
249 uid = 0
250 gid = 0
251
252 [test-from]
253         path = $fromdir
254         read only = yes
255         comment = r/o
256
257 [test-to]
258         path = $todir
259         read only = no
260         comment = r/w
261
262 [test-scratch]
263         path = $scratchdir
264         read only = no
265
266 [test-hidden]
267         path = $fromdir
268         list = no
269 EOF
270
271     # Build a helper script to ignore exit code 23
272     ignore23="$scratchdir/ignore23"
273     echo "building help script $ignore23"
274
275     cat >"$ignore23" <<'EOT'
276 if "${@}"; then
277     exit
278 fi
279
280 ret=$?
281
282 if test $ret = 23; then
283     exit
284 fi
285
286 exit $ret
287 EOT
288 chmod +x "$ignore23"
289 }
290
291
292 build_symlinks() {
293     mkdir "$fromdir"
294     date >"$fromdir/referent"
295     ln -s referent "$fromdir/relative"
296     ln -s "$fromdir/referent" "$fromdir/absolute"
297     ln -s nonexistent "$fromdir/dangling"
298     ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
299 }
300
301 test_fail() {
302     echo "$@" >&2
303     exit 1
304 }
305
306 test_skipped() {
307     echo "$@" >&2
308     echo "$@" > "$tmpdir/whyskipped"
309     exit 77
310 }
311
312 # It failed, but we expected that.  don't dump out error logs, 
313 # because most users won't want to see them.  But do leave
314 # the working directory around.
315 test_xfail() {
316     echo "$@" >&2
317     exit 78
318 }
319
320 # Determine what shell command will appropriately test for links.
321 ln -s foo "$scratchdir/testlink"
322 for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
323 do
324     for switch in -h -L
325     do
326         if $cmd $switch "$scratchdir/testlink" 2>/dev/null
327         then
328             # how nice
329             TEST_SYMLINK_CMD="$cmd $switch"
330             # i wonder if break 2 is portable?
331             break 2
332         fi
333    done
334 done
335 # ok, now get rid of it
336 rm "$scratchdir/testlink"
337
338
339 if [ "x$TEST_SYMLINK_CMD" = 'x' ]
340 then
341     test_fail "Couldn't determine how to test for symlinks"
342 else
343     echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
344 fi
345         
346
347 # Test whether something is a link, allowing for shell peculiarities
348 is_a_link() {
349     # note the variable contains the first option and therefore is not quoted
350     $TEST_SYMLINK_CMD "$1"
351 }
352
353
354 # We need to set the umask to be reproducible.  Note also that when we
355 # do some daemon tests as root, we will setuid() and therefore the
356 # directory has to be writable by the nobody user in some cases.  The
357 # best thing is probably to explicitly chmod those directories after
358 # creation.
359  
360 umask 022